<?php

function chat_user_main()
{
    if (!(SecurityUtil::checkPermission('chat::', '::', ACCESS_READ)))
        return LogUtil::registerPermissionError();
 
    $currLang = pnSessionGetVar('lang', 'eng');
    $langs = array();
    $langs['eng'] = 'en_US';

    $hosting_mode        = pnModGetVar ('chat', 'hosting_mode');
    $chat_server_path    = pnModGetVar ('chat', 'chat_server_path');
    $client_location     = pnModGetVar ('chat', 'client_location');
    $chat_room_name      = pnModGetVar ('chat', 'chat_room_name');
    $chat_client_width   = pnModGetVar ('chat', 'chat_client_width');
    $chat_client_height  = pnModGetVar ('chat', 'chat_client_height');
    $free_server_path    = 'http://free.123flashchat.com/';
    
    if (!$hosting_mode) 
        $delay = 3;
    if (!$chat_client_width) 
        $chat_client_width = 643;
    if (!$chat_client_height) 
        $chat_client_height = 512;
    if (!$title) 
        $title = 'Chat';


	$params = getChatters( $hosting_mode, $free_server_path, $chat_room_name, $client_location, $chat_server_path);
	$params['userlist'] = getChatterList( $hosting_mode, $free_server_path, $chat_room_name, $client_location, $chat_server_path);

	switch($hosting_mode)
	{

		case 1:
			$params['swf_url'] = local_mode($client_location);
			break;
		case 2:
			$params['swf_url'] = host_mode($client_location);
			break;
	}

    $params['hosting_mode']            = $hosting_mode ;
    $params['chat_server_path']        = $chat_server_path;
	$params['client_location']         = $client_location;
    $params['chat_room_name']          = empty($chat_room_name)?$_SERVER['HTTP_HOST']:$chat_room_name;
    $params['chat_client_width']       = $chat_client_width;
    $params['chat_client_height']      = $chat_client_height;
	
	if(!empty($_SESSION['PNSVuid']))
	{
   		$userinfo = pnUserGetVars($_SESSION['PNSVuid']);
		$params['swf_url'] .= '&init_user='.$userinfo['uname'].'&init_password='.$userinfo['pass'];
		$params['username'] = $userinfo['uname'];
	}

     $pnRender = pnRender::getInstance('chat');
	 $pnRender->assign ('params',   $params);
     return $pnRender->fetch('chat_user_view.html');
	
}


function host_mode($client_location)
{


	$client_location = checkSlash($client_location);
	$client_location = 'http://'.str_replace('http://','',$client_location);
	$urlinfo = getHostParameters($client_location);
	$swfname = basename($urlinfo['path']);   
	parse_str($urlinfo['query']);
	
	$client_location = 'http://'.str_replace('http://','',$client_location);	
	$swfurl = 'http://'.str_replace("http://",'',$client_location).$swfname;


	if(!empty($init_host)){
		$swfurl .= (strpos($swfurl,"?"))?"&init_host=".$init_host:"?init_host=".$init_host;
	}
	if(!empty($init_port)){
		$swfurl .= (strpos($swfurl,"?"))?"&init_port=".$init_port:"?init_port=".$init_port;
	}
	if(!empty($init_group)){
		$swfurl .= (strpos($swfurl,"?"))?"&init_group=".$init_group:"?init_host=".$init_group;
	}
	if(!empty($username)){
		$swfurl .= (strpos($swfurl,"?"))?"&init_user=".rawurlencode($username):"?init_user=".rawurlencode($username);
	}
	if(!empty($password)){
		$swfurl .= (strpos($swfurl,"?"))?"&init_password=".rawurlencode($password):"?init_password=".rawurlencode($password);
	}
	
	return $swfurl;

}


function local_mode($client_location )
{
	$client_location = checkSlash($client_location);
	$client_location = 'http://'.str_replace('http://','',$client_location);
	$swfname = '123flashchat.swf';
	$init_group = '?init_group=defaule';
	$swfurl = 'http://'.str_replace("http://",'',$client_location).$swfname.$init_group;
    
	return $swfurl;
}

function getHostParameters($client_location)
{
	$content = @file_get_contents($client_location);
	if(!empty($content))
	{
		$pattern = '|var urlValue="(.*)"|U';
		preg_match($pattern, $content, $matches);
		if(!empty($matches[1]))
		{
			$url = $matches[1];
			$urlinfo = parse_url($url);
			return $urlinfo;
		}
		else
		{
			$pattern = '|PARAM NAME=movie VALUE="(.*)"|U';
			preg_match($pattern, $content, $matches);
			if(!empty($matches[1]))
			{
				$url = $matches[1];
				$urlinfo = parse_url($url);
				return $urlinfo;
			}
		}
		return false;
	}
}



function getChatterList( $running_mode, $free_server_path, $room_name, $client_location, $chat_data_path) 
{
	
	if ($running_mode == 1) {
		
		return chat_getChatterListFromLocalServer ( checkSlash($chat_data_path) );
	} else if ($running_mode == 2) {
		return chat_getChatterListFromExtendServer ( $client_location );
	} else if ($running_mode == 3) {
		return chat_getChatterListFromFreeServer ( $free_server_path, $room_name );
	}

}

function getChatters( $running_mode, $free_server_path, $room_name, $client_location, $chat_data_path) 
{


	if ($running_mode == 1) {
		
		return chat_getChattersFromLocalServer ( checkSlash($chat_data_path) );
	} else if ($running_mode == 2) {
		return chat_getChattersFromExtendServer ( $client_location );
	} else if ($running_mode == 3) {
		return chat_getChattersFromFreeServer ( $free_server_path, $room_name );
	}

}



function chat_getChatterListFromFreeServer($free_server_path, $roomname) {
	if ($roomname == '')
		$roomname = $_SERVER ['HTTP_HOST'];
	$userListStr = "<script lanauge=javascript src='" . $free_server_path . "freeroomuser.php?roomname=" . rawurlencode ( $roomname ) . "'></script>";
	return $userListStr;
}

function chat_getChattersFromFreeServer($free_server_path, $roomname) {
	$room = array ();
	if ($roomname == '')
		$roomname = $_SERVER ['HTTP_HOST'];
	$room ['logon_users'] = "<script lanauge=javascript src='" . $free_server_path . "freeroomnum.php?roomname=" . rawurlencode ( $roomname ) . "'></script>";
	return $room;
}

function chat_getChattersFromLocalServer($chat_data_path) {
	
	$room = array ();
	$room ['connections'] = 0;
	$room ['logon_users'] = 0;
	$room ['room_numbers'] = 0;
	
	$online_file = $chat_data_path . "online.txt";
	
	if (! file_exists ( $online_file )) {
		return $room;
	}
	
	if (! $row = file ( $online_file )) {
		return $room;
	}
	
	$room_data = explode ( "|", $row [0] );
	
	if (count ( $room_data ) == 3) {
		$room ['connections'] = intval ( $room_data [0] );
		$room ['logon_users'] = intval ( $room_data [1] );
		$room ['room_numbers'] = intval ( $room_data [2] );
	}
	
	return $room;
}

function chat_getChattersFromExtendServer($client_location) {
	$room = array ();
	
    $client_location = checkSlash($client_location);
	$room ['connections'] = "<script lanauge=javascript src='http://" . str_replace("http://",'',$client_location) . "connections.php'></script>";
	$room ['logon_users'] = "<script lanauge=javascript src='http://" . str_replace("http://",'',$client_location) . "logon_users.php'></script>";
	$room ['room_numbers'] = "<script lanauge=javascript src='http://" . str_replace("http://",'',$client_location) . "room_numbers.php'></script>";
	
	return $room;
}

function chat_getChatterListFromLocalServer($chat_data_path) {
	
	
	if(!@dir($chat_data_path))return "chat data path error";
	
	$userListStr = "";
	
	$d = dir ( $chat_data_path );
	
	while ( false !== ($entry = $d->read ()) ) {
		$rest = substr ( $entry, 0, 5 );
		if ($rest == "room_") {
			
			if (file_exists ( $chat_data_path . $entry )) {
				
				$f_users = file ( $chat_data_path . $entry );
				
				for($i = 0; $i < count ( $f_users ); $i ++) {
					$f_line = trim ( $f_users [$i] );
					
					if ($f_line != "") {
						$userListStr = ($userListStr == "") ? $f_line : $userListStr . "," . $f_line;
					}
				}
			
			}
		}
	
	}
	$d->close ();
	
	$userListStr = ($userListStr == "") ? "None" : $userListStr;
	return $userListStr;
}

function chat_getChatterListFromExtendServer($client_location) {
    $client_location = checkSlash($client_location);
	$userListStr = "<script lanauge=javascript src='http://" . str_replace("http://",'',$client_location) . "user_list.php'></script>";
	$userListStr = (empty ( $userListStr )) ? "None" : $userListStr;
	return $userListStr;
}



function checkSlash($path)
{
		if(substr($path,-1,1) != "/" && !empty($path)){
			$path = $path."/";
		}
		return $path;
}
